/*************************************************************************
   AntiRight
   (c) 2003 Jeffrey Bedard
   jefbed@e-list.net
 
   This file is part of AntiRight.

    AntiRight is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    AntiRight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AntiRight; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/* This is AntiRight. AntiRight is a program that is meant to provide
   a lightweight control panel for the system.  AntiRight makes it
   easier to perform everyday system commands from the push of a
   button.  AntiRight was developed with Lesstif.
   
   This program is distributed under the terms of the GNU General
   Public Lecense.  To find out more, look at the file called COPYING
   in the project root directory.  */



/* This is the version control header.  */
/* 	$Id: antiload.c,v 1.1 2003/10/10 22:22:29 jefbed Exp $  */

#include <time.h>
#include "../antiright-src/antiright.h"
#include "antiload.xbm"

Widget antiload_label;
Window window;
Display *display;
XGCValues gc_values;
GC gc;

/* These animations are creaping featurism and they will be removed
   immediately.  */
void
draw_line(int x1, int y1,
	  int x2, int y2)
{
  XDrawLine(display, window, gc, x1, y1, x2, y2);
}

void
antiload_update()
{
  char hostname[32];
  char *load_string;
  double load_average[3];
  int x;

  XClearWindow(display,
	       window);
  /*XSetFont(display, gc,
	   XLoadFont(display,
	   "-*-helvetica-bold-r-normal-*-18-*-*-*-*-*-*-*"));*/

  /* Begin system monitor.  */

  if(gethostname(hostname, 32) != -1)
    {
      load_string=antiright_strcat("Load for ", hostname);
    }
  else
    {
      load_string="Load Meter";
    }
  /*  XSetFont(display, gc,
	   XLoadFont(display,
	   "-*-helvetica-*-r-*-*-14-*-*-*-*-*-*-*"));*/
  XSetFont(display, gc,
	   XLoadFont(display,
	   "8x16"));
  XDrawString(display, window, gc, 4,16,
	      load_string, strlen(load_string));
  /*  uptime_string="Uptime";
  
  XDrawString(display, window, gc, 4,124,
  uptime_string, strlen(uptime_string));*/

  getloadavg(load_average, 3);
  XSetLineAttributes(display, gc, 16, LineSolid, CapRound, JoinRound);
  XSetFont(display, gc,
	   XLoadFont(display,
	   "fixed"));
  /* Begin one minute load.  */
  load_string="1 min.";
  x=abs(load_average[0]*100);
  XDrawLine(display, window, gc,
	    0, 32,
	    x, 32);
  XDrawString(display, window, gc, x+16,36,
	      load_string, strlen(load_string));
  
  /* Begin five minute load.  */
  load_string="5 min.";
  x=abs(load_average[1]*100);
  XDrawLine(display, window, gc,
	    0, 64,
	    x, 64);
  XDrawString(display, window, gc, x+16,68,
	      load_string, strlen(load_string));

  /* Begin fifteen minute load.  */
  load_string="15 min.";
  x=abs(load_average[2]*100);
  XDrawLine(display, window, gc,
	    0, 96,
	    x, 96);
  XDrawString(display, window, gc, x+16,100,
	      load_string, strlen(load_string));

  
  XFlush(display);
}

void
antiload_update_work_procedure(XtPointer client_data,
				      XtIntervalId* timer_id)
{
  antiload_update();
  *timer_id=
    XtAppAddTimeOut(app_context,
		    1000, /* 1 second.  */
		    antiload_update_work_procedure,
		    client_data);
}

int
main(int argc, char* argv[])    
{
  Widget menu_widget;
  Widget menubar_widget;
  Widget mainwindow_widget;
  
  antiright_initialize_application(argc, argv);
  
  antiright_set_icon(antiright_parent_widget,
		     "Antiload",
		     antiload_bits,
		     antiload_width,
		     antiload_height);

  mainwindow_widget= 
    XtVaCreateManagedWidget("Row", 
			    xmRowColumnWidgetClass, 
			    antiright_parent_widget, 
			    XmNorientation, 
			    XmVERTICAL,
			    NULL);

  antiright_number_arguments=0;
  menubar_widget= 
    XmCreateMenuBar(mainwindow_widget, 
		    "menubar", 
		    antiright_arguments, 
		    antiright_number_arguments);
  XtManageChild(menubar_widget);
  menu_widget = antiright_create_pulldown_menu(menubar_widget, "File");
  antiright_create_button(menu_widget, 
			  "Close", 
			  exit_cb, 
			  "Close");
  
  menu_widget=antiright_create_help_menu(menubar_widget);
  antiright_number_arguments=0;
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNwidth, 
	   256);
  antiright_number_arguments++;
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNheight, 
	   108);
  antiright_number_arguments++;
  antiload_label=XmCreateDrawingArea(mainwindow_widget,
				      "Antiload",
				      antiright_arguments,
				      antiright_number_arguments);
  XtAddCallback(antiload_label,
		XmNexposeCallback,
		antiload_update,
		NULL);
  XtAddCallback(antiload_label,
		XmNinputCallback,
		antiload_update,
		NULL);
  XtAddCallback(antiload_label,
		XmNresizeCallback,
		antiload_update,
		NULL);
  XtManageChild(antiload_label);  
  XtManageChild(menubar_widget);
  XtManageChild(mainwindow_widget);

  XtRealizeWidget(antiright_parent_widget);
 

  display=XtDisplay(antiload_label);
  window=XtWindow(antiload_label);
  
      
  gc=XCreateGC(display,
	       window,
	       0,
	       NULL);
  
  XFlush(display); /* I don't know why this works here.  */
 
  XtAppAddTimeOut(app_context,
		  1000,
		  antiload_update_work_procedure,
		  NULL);
  antiload_update();
    
  XtAppMainLoop(app_context);
  return(0);
}















