/*************************************************************************
   AntiRight
   (c) 2003 Jeffrey Bedard
   jefbed@e-list.net
 
   This file is part of AntiRight.

    AntiRight is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    AntiRight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AntiRight; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/* This is AntiRight. AntiRight is a desktop environment that is meant
   to provide a lightweight interface to the system.  AntiRight makes
   it easier to perform everyday system commands from the push of a
   button. 
*/
#define vcid "$Id: antiright.c,v 1.5 2003/10/10 22:22:29 jefbed Exp $";


#include "antiright.h"
#include "antiright.xbm"


/* This is the body of the application.  This sets up all of the main
   window's widgets, the menus, and the callbacks.  */
int
antiright_main(int argc, char **argv)    
{
  Widget menu_widget;
  Widget mainwindow_widget;
  Widget text_field;
  Widget menubar_widget;
  Widget main_row_widget; 
  Widget first_row_widget; 
  Widget second_row_widget; 
  Widget third_row_widget; 
  Widget bottom_row_widget;
  Widget form_widget;
  Widget submenu_widget;
  Widget child_widget;
  Widget calculator_widget;
  Widget calculator_label;
  Widget command_label;
  
  antiright_initialize_application(argc, argv);
  antiright_set_icon(antiright_parent_widget,
		     "AntiRight",
		     antiright_bits,
		     antiright_width,
		     antiright_height);

  antiright_number_arguments=0;
  mainwindow_widget=
    XmCreateMainWindow(antiright_parent_widget, 
		       "main", 
		       antiright_arguments, 
		       antiright_number_arguments);
  XtManageChild(mainwindow_widget);
  
  
  antiright_number_arguments=0;
  menubar_widget=
    XmCreateMenuBar(mainwindow_widget, 
		    "menubar", 
		    antiright_arguments, 
		    antiright_number_arguments);
  XtManageChild(menubar_widget);
  menu_widget=
    antiright_create_pulldown_menu(menubar_widget, 
				   "File");
  
  antiright_create_button(menu_widget, 
			  "New", 
			  antiright_new_cb, 
			  "New");
  antiright_create_button(menu_widget, 
			  "Open", 
			  antiright_open_file, 
			  "Open");
  antiright_create_separator(menu_widget);
  
  antiright_create_button(menu_widget, 
			  "Close", 
			  exit_cb, 
			  "Close");  

  menu_widget = 
    antiright_create_pulldown_menu(menubar_widget, 
				   "View");
  
  antiright_create_button(menu_widget, 
			  "Mail", 
			  antiright_system_cb, 
			  MAIL);
  antiright_create_separator(menu_widget);
  submenu_widget=
    antiright_create_pulldown_menu(menu_widget, 
				   "Utilities");
  antiright_create_button(submenu_widget,
			  "Edit X Resources",
			  antiright_system_cb,
			  "editres &");
  antiright_create_button(submenu_widget,
			  "Read X Resources",
			  antiright_system_cb,
			  "nice xrdb ~/.Xdefaults");
  antiright_create_button(submenu_widget, 
			  "System Monitor", 
			  antiright_system_cb, 
			  "nice xterm -e top &");
  antiright_create_button(submenu_widget, 
			  "Sticky Notes", 
			  antiright_system_cb, 
			  "nice xmsticky &");
  antiright_create_button(submenu_widget, 
			  "Clock", 
			  antiright_system_cb, 
			  "nice anticlock &");
  submenu_widget=
    antiright_create_pulldown_menu(menu_widget, 
				   "Applications");
  antiright_create_button(submenu_widget, 
			  "Text Editor", 
			  antiright_system_cb, 
			  "xmtextedit &");
  antiright_create_button(submenu_widget,
			  "Image Editor", 
			  antiright_system_cb, 
			  IMAGE_EDITOR); 
  /* bitmap should be found on all X workstations.  */
  
  antiright_create_button(submenu_widget, 
			  "WWW Browser", 
			  antiright_system_cb,
			  BROWSER);
  antiright_create_button(submenu_widget, 
			  "CD Player", 
			  antiright_system_cb, 
			  "arcd &");
  submenu_widget=
    antiright_create_pulldown_menu(menu_widget, 
				   "File Systems");
  antiright_create_button(submenu_widget, 
			  "Mount", 
			  antiright_mount_cb, 
			  "Mount");
  antiright_create_button(submenu_widget, 
			  "Unmount", 
			  antiright_unmount_cb, 
			  "Unmount");
  antiright_create_separator(submenu_widget);
  antiright_create_button(submenu_widget, 
			  "Show All", 
			  antiright_system_cb, 
			  "xmmessage \"`cat /etc/fstab`\" &");
  submenu_widget=
    antiright_create_pulldown_menu(menu_widget, 
				   "Administration");
  antiright_create_button(submenu_widget, 
			  "Root Shell", 
			  antiright_system_cb, 
			  "xterm -e su &");
  antiright_create_button(submenu_widget, 
			  "Remove Backup Files", 
			  antiright_system_cb, 
			  "rm *~ &");
  antiright_create_button(submenu_widget, 
			  "Remove Temporary Files", 
			  antiright_system_cb, 
			  "rm /tmp/* &");
  antiright_create_button(submenu_widget, 
			  "Update Locate Database", 
			  antiright_system_cb, 
			  "updatedb");
  antiright_create_separator(submenu_widget);
  antiright_create_button(submenu_widget, 
			  "See All Processes", 
			  antiright_system_cb, 
			  "xmmessage \"`ps xa`\" &");
  antiright_create_button(submenu_widget, 
			  "See All Users", 
			  antiright_system_cb, 
			  "xmmessage \"`who`\" &");
  antiright_create_button(submenu_widget, 
			  "See Disk Info", 
			  antiright_system_cb, 
			  "xmmessage \"`df`\" &");
  
  antiright_create_separator(submenu_widget);
  antiright_create_button(submenu_widget, 
			  "Open Display to Host...", 
			  antiright_xhost_cb, 
			  "xhost tool");
  
#ifdef HAVE_PPP			       
  antiright_create_separator(submenu_widget);
  antiright_create_button(submenu_widget, 
			  "Internet On", 
			  antiright_system_cb, 
			  "wvdial &");
  antiright_create_button(submenu_widget, 
			  "Internet Off", 
			  antiright_system_cb, 
			  "killall wvdial &");
#endif /*  HAVE_PPP */
  
  
  menu_widget=
    antiright_create_pulldown_menu(menubar_widget, 
				   "Options");
  
  /*End Preferences submenu.  */
  
  antiright_create_button(menu_widget, 
			  "Backdrop Editor", 
			  antiright_background_tool_cb, 
			  NULL);
  antiright_create_button(menu_widget, 
			  "X Theme Selector", 
			  antiright_theme_manager_cb, 
			  NULL);
  antiright_create_button(menu_widget, 
			  "Security Settings", 
			  antiright_security_cb, 
			  NULL);
  antiright_create_button(menu_widget, 
			  "Disk Settings", 
			  antiright_disk_cb, 
			  NULL);  

  /* This is the application launcher panel.  */
  antiright_create_help_menu(menubar_widget);
  main_row_widget=
    XtVaCreateManagedWidget("Row", 
			    xmRowColumnWidgetClass, 
			    mainwindow_widget,
			    XmNorientation, 
			    XmHORIZONTAL, 
			    NULL);
  XtManageChild(main_row_widget);
  first_row_widget=
    XtVaCreateManagedWidget("row1", 
			    xmRowColumnWidgetClass,
			    main_row_widget, 
			    XmNorientation, 
			    XmVERTICAL, 
			    NULL);
  XtManageChild(first_row_widget);

  antiright_create_button(first_row_widget, 
			  "Mail", 
			  antiright_system_cb, 
			  MAIL);
  antiright_create_button(first_row_widget, 
			  "Text Editor", 
			  antiright_system_cb, 
			  "xmtextedit &");
  antiright_create_button(first_row_widget, 
			  "CD Player", 
			  antiright_system_cb, 
			  "arcd &");
  antiright_create_button(first_row_widget, 
			  "File Manager", 
			  antiright_filemanager_cb, 
			  "File Manager");
  
  
  second_row_widget=
    XtVaCreateManagedWidget("row1", 
			    xmRowColumnWidgetClass,
			    main_row_widget, 
			    XmNorientation, 
			    XmVERTICAL, 
			    NULL);
  XtManageChild(second_row_widget);
  antiright_create_button(second_row_widget, 
			  "Terminal", 
			  antiright_system_cb, 
			  "xterm &");
  antiright_create_button(second_row_widget, 
			  "Browser", 
			  antiright_system_cb, 
			  BROWSER); /* Defined in config.template.  */
  antiright_create_button(second_row_widget, 
			  "Sticky Notes", 
			  antiright_system_cb, 
			  "nice xmsticky &");
  antiright_create_button(second_row_widget,
			  "Disk Manager", 
			  antiright_disk_cb, 
			  NULL);

  third_row_widget=
    XtVaCreateManagedWidget("row1", 
			    xmRowColumnWidgetClass,
			    main_row_widget, 
			    XmNorientation, 
			    XmVERTICAL, 
			    NULL);
  XtManageChild(third_row_widget);
  antiright_number_arguments=0;
  antiright_create_button(third_row_widget, 
			  "Load Meter", 
			  antiright_system_cb, 
			  "nice antiload &");
  antiright_create_button(third_row_widget, 
			  "Clock", 
			  antiright_system_cb, 
			  "nice anticlock &");
  /* Be considerate to ppp users like me */			  
#ifdef HAVE_PPP
  antiright_create_button(third_row_widget, 
			  "Internet On", 
			  antiright_system_cb, 
			  "wvdial &");
  antiright_create_button(third_row_widget, 
			  "Internet Off", 
			  antiright_system_cb, 
			  "killall wvdial &");
#else	/*optimize for a non-dialup machine */
  antiright_create_button(third_row_widget, 
			  "See Disk Info", 
			  antiright_system_cb, 
			  "xmmessage \"`df`\" &");	
  antiright_create_button(third_row_widget, 
			  "Processes", 
			  antiright_system_cb, 
			  "xmmessage \"`ps xa`\" &");			  
#endif /* HAVE_PPP  */			
  
  
  
  
  
  /* This is the end of the application panel.  */
  
  bottom_row_widget= 
    XtVaCreateManagedWidget("row", 
			    xmRowColumnWidgetClass, 
			    mainwindow_widget,
			    XmNorientation, 
			    XmVERTICAL,
			    NULL);
  XtManageChild(bottom_row_widget);
  
  /* Change first_row_widget to form later on.  */
  form_widget=
    XtVaCreateManagedWidget("row", 
			    xmFormWidgetClass, 
			    bottom_row_widget,
			    NULL);
  
  XtManageChild(first_row_widget);
  
  
  
  calculator_label=
    XtVaCreateManagedWidget("Calculator:",
			    xmLabelWidgetClass, 	    
			    form_widget,
			    XmNtopAttachment,
			    XmATTACH_FORM,
			    XmNleftAttachment,
			    XmATTACH_FORM,
			    XmNrightAttachment,
			    XmATTACH_POSITION,
			    XmNrightPosition,
			    35,
			    XmNalignment,
			    XmALIGNMENT_END,
			    NULL);	
  XtManageChild(calculator_label);			    
  
  antiright_number_arguments=0;
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNtopAttachment,
	   XmATTACH_FORM); 
  antiright_number_arguments++;
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNleftAttachment,
	   XmATTACH_WIDGET); 
  antiright_number_arguments++;
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNleftWidget,
	   calculator_label); 
  antiright_number_arguments++;
  
  calculator_widget=		  
    XltCreateNumEntry(form_widget, 
		      "Calculator", 
		      antiright_arguments, 
		      antiright_number_arguments);
  XtManageChild(calculator_widget);
  child_widget=
    XltNumEntryGetChild(calculator_widget,
			XltNUMENTRY_UP);
  XtUnmanageChild(child_widget);
  child_widget=
    XltNumEntryGetChild(calculator_widget,
			XltNUMENTRY_DN);
  XtUnmanageChild(child_widget);
  child_widget=
    XltNumEntryGetChild(calculator_widget,
			XltNUMENTRY_LAB);
  XtUnmanageChild(child_widget);
  
  command_label=
    XtVaCreateManagedWidget("Shell Command:",
			    xmLabelWidgetClass, 		    
			    form_widget,
			    XmNtopAttachment,
			    XmATTACH_WIDGET,
			    XmNtopWidget,
			    calculator_label,
			    XmNleftAttachment,
			    XmATTACH_FORM,
			    XmNbottomAttachment,
			    XmATTACH_FORM,
			    XmNrightAttachment,
			    XmATTACH_POSITION,
			    XmNrightPosition,
			    35,	
			    XmNalignment,
			    XmALIGNMENT_END,
			    NULL);
  XtManageChild(command_label);		
  
  
  antiright_number_arguments=0;
  
  XtSetArg(
	   antiright_arguments[antiright_number_arguments], 
	   XmNcolumns, 
	   24);
  antiright_number_arguments++;
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNtopAttachment,
	   XmATTACH_WIDGET); 
  antiright_number_arguments++;
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNtopWidget,
	   calculator_widget); 
  antiright_number_arguments++;
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNbottomAttachment,
	   XmATTACH_FORM); 
  antiright_number_arguments++;
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNleftAttachment,
	   XmATTACH_WIDGET); 
  antiright_number_arguments++;
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNleftWidget,
	   command_label); 
  antiright_number_arguments++;
  text_field = 
    XmCreateTextField(form_widget, 
		      "Text", 
		      antiright_arguments, 
		      antiright_number_arguments); 
  
  XtAddCallback(text_field, 
		XmNactivateCallback, 
		antiright_command_cb,
		&text_field);
  XtManageChild(text_field);
  
  antiright_number_arguments=0;
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNeditMode, 
	   XmMULTI_LINE_EDIT ); 
  antiright_number_arguments++;
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNrows, 
	   1 );
  antiright_number_arguments++;		    
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNscrollVertical, 
	   True ); 
  antiright_number_arguments++;
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNeditable, 
	   False); 
  antiright_number_arguments++;
  XtSetArg(antiright_arguments[antiright_number_arguments],
	   XmNscrollHorizontal, 
	   False );
  antiright_number_arguments++;
  XtSetArg(antiright_arguments[antiright_number_arguments],
	   XmNcursorPositionVisible, 
	   False );
  antiright_number_arguments++;
  
  antiright_status_widget=
    XmCreateScrolledText(bottom_row_widget, 
			 "status", 
			 antiright_arguments, 
			 antiright_number_arguments);
  XtManageChild(antiright_status_widget);
 
  XmTextInsert(antiright_status_widget,
	       XmTextGetInsertionPosition(antiright_status_widget),
	       "Fight Software Patents!");
 
  XmMainWindowSetAreas(mainwindow_widget, 
		       menubar_widget, 
		       main_row_widget, 
		       NULL, 
		       NULL, 
		       bottom_row_widget);
  XtRealizeWidget(antiright_parent_widget);
  XtAppMainLoop(app_context);
  return(0);
}
