/*************************************************************************
   AntiRight
   (c) 2003 Jeffrey Bedard
   jefbed@e-list.net
 
   This file is part of AntiRight.

    AntiRight is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    AntiRight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AntiRight; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "antiright.h"

int 
antiright_background_tool()
{
  Widget dialog;
  Widget row[3];
  Widget child;
  antiright_number_arguments = 0;
  dialog= 
      XmCreateMessageDialog(antiright_parent_widget, 
			    "Background", 
			    antiright_arguments, 
			    antiright_number_arguments);
  child=XmMessageBoxGetChild(dialog, 
			     XmDIALOG_OK_BUTTON);
  XtUnmanageChild(child);
  antiright_number_arguments = 0;
  XtSetArg(antiright_arguments[antiright_number_arguments],
	   XmNorientation,
	   XmHORIZONTAL);
  antiright_number_arguments++;
  row[0]=
      XmCreateRowColumn(dialog,
			"row0",
			antiright_arguments,
			antiright_number_arguments);
  XtManageChild(row[0]);
  
  
  antiright_number_arguments = 0;
  XtSetArg(antiright_arguments[antiright_number_arguments],
	   XmNorientation,
	   XmVERTICAL);
  antiright_number_arguments++;
  row[1]=XmCreateRowColumn(row[0],
			   "row1",
			   antiright_arguments,
			   antiright_number_arguments);
  XtManageChild(row[1]);
  antiright_create_button(row[1],
			  "Solid Red",
			  antiright_system_cb,
			  "xsetroot -solid red4"); 
  antiright_create_button(row[1],
			  "Solid Yellow",
			  antiright_system_cb,
			  "xsetroot -solid yellow"); 
  antiright_create_button(row[1],
			  "Solid Black",
			  antiright_system_cb,
			  "xsetroot -solid black"); 
  antiright_create_button(row[1],
			  "Solid Grey",
			  antiright_system_cb,
			  "xsetroot -solid grey"); 
  antiright_create_button(row[1],
			  "Solid Sky Blue",
			  antiright_system_cb,
			  "xsetroot -solid skyblue3"); 
  
  antiright_number_arguments=0;
  XtSetArg(antiright_arguments[antiright_number_arguments],
	   XmNorientation,
	   XmVERTICAL);
  antiright_number_arguments++;
  row[1]=XmCreateRowColumn(row[0],
			   "row1",
			   antiright_arguments,
			   antiright_number_arguments);
  XtManageChild(row[1]);
  antiright_create_button(row[1],
			  "Default Stipple",
			  antiright_system_cb,
			  "xsetroot -default"); 
  antiright_create_button(row[1],
			  "Grey Stipple",
			  antiright_system_cb,
			  "xsetroot -grey"); 
  antiright_create_button(row[1],
			  "Rose",
			  antiright_system_cb,
			  "xsetroot -solid mistyrose3"); 
  antiright_create_button(row[1],
			  "AntiRight Tile",
			  antiright_system_cb,
			  "xsetroot -bitmap /usr/local/share/doc/antiright/antiright.xbm -bg red4 -fg yellow");
  antiright_create_button(row[1],
			  "Olive Green",
			  antiright_system_cb,
			  "xsetroot -solid darkolivegreen");
  
  
  antiright_number_arguments=0;
  XtSetArg(antiright_arguments[antiright_number_arguments],
	   XmNorientation,
	   XmVERTICAL);
  antiright_number_arguments++;
  row[1]=XmCreateRowColumn(row[0],
			   "row1",
			   antiright_arguments,
			   antiright_number_arguments);
  XtManageChild(row[1]);
  antiright_create_button(row[1],
			  "Dark Sky Blue",
			  antiright_system_cb,
			  "xsetroot -solid skyblue4"); 
  antiright_create_button(row[1],
			  "Dark Thistle",
			  antiright_system_cb,
			  "xsetroot -solid thistle4"); 
  antiright_create_button(row[1],
			  "Slate Grey",
			  antiright_system_cb,
			  "xsetroot -solid lightslategrey"); 
  antiright_create_button(row[1],
			  "Wheat",
			  antiright_system_cb,
			  "xsetroot -solid wheat3");
  antiright_create_button(row[1],
			  "Azure",
			  antiright_system_cb,
			  "xsetroot -solid azure3");
  

  XtAddCallback(dialog,
		XmNhelpCallback,
		antiright_help_cb,
		"Use this tool to change the desktop background.");
  
  XtManageChild(dialog);
  return(0);
}

void 
antiright_background_tool_cb()
{
    antiright_background_tool();
}
