/*************************************************************************
   AntiRight
   (c) 2003 Jeffrey Bedard
   jefbed@e-list.net
 
   This file is part of AntiRight.

    AntiRight is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    AntiRight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AntiRight; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "antiright.h"

void 
antiright_mount_ok_cb(Widget widget,
		      XtPointer client_data,
		      XtPointer call_data)
{
  XmFileSelectionBoxCallbackStruct* callback_struct_pointer;
  char *text, *command;
  
  callback_struct_pointer=call_data;
  XmStringGetLtoR(callback_struct_pointer->value,
		  XmSTRING_DEFAULT_CHARSET,
		  &text);
  command=antiright_strcat("mount ", text);
  command=antiright_strcat(command, " &");
  system(command);
  free(command);
  XtUnmanageChild(widget);
  client_data=NULL;
  XtFree(text);
}

void 
antiright_mount_cb(Widget parent,
		   XtPointer client_data,
		   XtPointer call_data)
{
  Widget dialog;
  dialog=XmCreatePromptDialog(parent,
			      client_data,
			      antiright_arguments,
			      antiright_number_arguments);
  XtAddCallback(dialog, 
		XmNhelpCallback, 
		antiright_help_cb, 
		"Enter the name of filesystem to mount.");
  XtAddCallback(dialog, 
		XmNokCallback, 
		antiright_mount_ok_cb, 
		"OK");
  XtManageChild(dialog);
  call_data=NULL;
}
void
antiright_unmount_ok_cb(Widget widget,
			XtPointer client_data,
			XtPointer call_data)
{
  XmFileSelectionBoxCallbackStruct* callback_struct_pointer;
  char *text, *command;
  
  callback_struct_pointer=call_data;
  XmStringGetLtoR(callback_struct_pointer->value,
		  XmSTRING_DEFAULT_CHARSET,
		  &text);
  command=antiright_strcat("unmount ", text);
  command=antiright_strcat(command, " &");
  system(command);
  free(command);
  XtUnmanageChild(widget);
  client_data=NULL;
  XtFree(text);
}

void 
antiright_unmount_cb(Widget widget,
		     XtPointer client_data,
		     XtPointer call_data)
{
  Widget dialog;
  call_data=NULL;
  dialog=XmCreatePromptDialog(widget,
				 client_data,
				 antiright_arguments,
				 antiright_number_arguments);
  XtAddCallback(dialog, 
		XmNhelpCallback, 
		antiright_help_cb, 
		"Enter the name of filesystem to unmount.");
  XtAddCallback(dialog, 
		XmNokCallback, 
		antiright_unmount_ok_cb, 
		"OK");
  XtManageChild(dialog);
}

void
antiright_disk_manager()
{
  Widget dialog;
  Widget child;
  Widget row[3];
  dialog= 
    XmCreateMessageDialog(antiright_parent_widget, 
			  "Disk_Settings", 
			  antiright_arguments, 
			  antiright_number_arguments);
  child=XmMessageBoxGetChild(dialog, 
			     XmDIALOG_OK_BUTTON);
  XtUnmanageChild(child);
  
  antiright_number_arguments = 0;
  XtSetArg(antiright_arguments[antiright_number_arguments],
	   XmNorientation,
	   XmHORIZONTAL);
	   antiright_number_arguments++;
  row[0]=
    XmCreateRowColumn(dialog,
		      "row0",
		      antiright_arguments,
		      antiright_number_arguments);
  XtManageChild(row[0]);
  
  
  antiright_number_arguments = 0;
  XtSetArg(antiright_arguments[antiright_number_arguments],
	   XmNorientation,
	   XmVERTICAL);
	   antiright_number_arguments++;
  row[1]=XmCreateRowColumn(row[0],
			   "row1",
			   antiright_arguments,
			   antiright_number_arguments);
  XtManageChild(row[1]);
  
      antiright_create_button(row[1],
				      "Mount Filesystem",
				      antiright_mount_cb,
				      "Mount Filesystem");
  
      antiright_create_button(row[1],
				      "Unmount Filesystem",
				      antiright_unmount_cb,
				      "Unmount Filesystem");
  
      antiright_create_button(row[1],
				      "See Filesystems",
				      antiright_system_cb,
				      "xmmessage \"`cat /etc/fstab`\" &");
  
  XtAddCallback(dialog,
		XmNhelpCallback,
		antiright_help_cb,
		"Use this tool to see and control filesystems.");
  XtAddCallback(dialog,
		XmNcancelCallback,
		cancel_cb,
		"Cancel");
  XtManageChild(dialog);
}
void antiright_disk_cb()
{
  antiright_disk_manager();    
}
