

/*************************************************************************
   AntiRight
   (c) 2003 Jeffrey Bedard
   jefbed@e-list.net
 
   This file is part of AntiRight.

    AntiRight is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Freex Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    AntiRight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AntiRight; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include "antiright.h"

/* REMEMBER!  Simplicity is key!  Elegance is decadence!  */

/*Please note that this file manager may be difficult for beginners to
  use as it tries to work around the motif file selection dialog.  */

/* Allow all filemanager functions to access file selection box.  */
Widget antiright_filemanager_widget;
/* Have a global filename to operate on for simplicity.  FIXME: Make
   filemanager modal.  */
char *antiright_filename;

void 
antiright_mkdir_cb()
{
  char *command;
  command=NULL;
  if(antiright_filename != NULL)
    {
      command=antiright_strcat("mkdir ", antiright_filename);
    }
  system(command);
  free(command);
}

void 
antiright_copy_ok_cb(Widget widget,
		     XtPointer client_data,
		     XtPointer call_data)
{
  XmFileSelectionBoxCallbackStruct* callback_struct_pointer;
  char *text, *command;
  
  callback_struct_pointer=call_data;
  
  XmStringGetLtoR(callback_struct_pointer->value,
		  XmSTRING_DEFAULT_CHARSET,
		  &text);
  command=antiright_strcat("cp ", antiright_filename);
  command=antiright_strcat(command, " ");
  command=antiright_strcat(command, text);
  command=antiright_strcat(command, " &");
  system(command);
  free(command);
  XtUnmanageChild(widget);
  client_data=NULL;
  XtFree(text);
}

void 
antiright_copy_cb()
{
  Widget dialog;
  Widget filter;
  
  filter=
    XmFileSelectionBoxGetChild(antiright_filemanager_widget, 
			       XmDIALOG_FILTER_TEXT);
 
				      
  dialog= 
    XmCreateFileSelectionDialog(antiright_parent_widget, 
			 "Destination", 
			 antiright_arguments, 
			 antiright_number_arguments);
  XtAddCallback(dialog, 
		XmNhelpCallback, 
		antiright_help_cb, 
		"Enter the name of the target file.");
  XtAddCallback(dialog, 
		XmNokCallback, 
		antiright_copy_ok_cb, 
		"OK");
  XtManageChild(dialog);
}

void 
antiright_delete_ok_cb()
{
  char *command;
  command=NULL;
  if(antiright_filename != NULL)
    {
      command=antiright_strcat("rm -f ", antiright_filename);
    }
  
  system(command);
  free(command);
}

void 
antiright_delete_cb()
{
  Widget dialog;
  XmString message;

  message=XmStringCreateLocalized("Are you sure?");
  antiright_number_arguments=0;
  XtSetArg(antiright_arguments[antiright_number_arguments],
	   XmNmessageString,
	   message);
  antiright_number_arguments++;
  dialog= 
    XmCreateQuestionDialog(antiright_parent_widget, 
			   "Delete", 
			   antiright_arguments, 
			   antiright_number_arguments);
  XtAddCallback(dialog, 
		XmNhelpCallback, 
		antiright_help_cb, 
		"Pressing OK will delete the selected file.");
  XtAddCallback(dialog,
		XmNokCallback,
		antiright_delete_ok_cb,
		"Delete");
  
  XtManageChild(dialog);
}
/* Apply selection.  */
void
antiright_filemanager_ok_cb(Widget widget,
			    XtPointer client_data,
			    XtPointer call_data)
{
  XmFileSelectionBoxCallbackStruct* callback_struct_pointer;

  widget=NULL;
  
  callback_struct_pointer=call_data;
  
  XmStringGetLtoR(callback_struct_pointer->value,
		  XmSTRING_DEFAULT_CHARSET,
		  &antiright_filename);
  client_data=NULL;
}
void
antiright_file_open_ok_cb(Widget widget,
			  XtPointer client_data,
			  XtPointer call_data)
{
  XmFileSelectionBoxCallbackStruct* callback_struct_pointer;
  char *command_string;

  callback_struct_pointer=call_data;
  
  XmStringGetLtoR(callback_struct_pointer->value,
		  XmSTRING_DEFAULT_CHARSET,
		  &antiright_filename);

  command_string=
    antiright_strcat(antiright_strcat("xmtextedit ", 
				      antiright_filename),
		     " &");
  antiright_check_return(system(command_string));
  puts(command_string);
  if(XtIsManaged(widget))
    {
      XtUnmanageChild(widget);
    }
  
  client_data=NULL;
}

void
antiright_filemanager_list_cb(Widget widget,
			      XtPointer client_data,
			      XtPointer call_data)
{
  puts("selected");
  widget=NULL;
  client_data=NULL;
  call_data=NULL;
}
 
   

int 
antiright_filemanager();
/* This is a callback calls the file manager function above.  */
/* This may be eliminated as it seems redundant.  */
void 
antiright_filemanager_cb()
{
  antiright_filemanager();
}

void
antiright_filemanager_unmanage_cb()
{
  XtUnmanageChild(antiright_filemanager_widget);
}
/* This creates a filemanager based on the lesstif file selection
   box.  */

int 
antiright_filemanager()
{
  Widget toolbar;
  Widget file_list;
  XmString apply_string;
  XmString close_string;

  apply_string=XmStringCreateLocalized("Apply");
  close_string=XmStringCreateLocalized("Close");
  
  antiright_number_arguments = 0;
  XtSetArg(antiright_arguments[antiright_number_arguments],
	   XmNokLabelString,
	   apply_string);
  antiright_number_arguments++;
  XtSetArg(antiright_arguments[antiright_number_arguments],
	   XmNcancelLabelString,
	   close_string);
  antiright_number_arguments++;
  antiright_filemanager_widget=
    XmCreateFileSelectionDialog(antiright_parent_widget,
				"FileManager",
				antiright_arguments,
				antiright_number_arguments);
  antiright_number_arguments = 0;
  toolbar=
    XtVaCreateManagedWidget("toolbar", 
			    xmRowColumnWidgetClass, 
			    antiright_filemanager_widget,
			    XmNorientation, 
			    XmHORIZONTAL,
			    NULL);
  XtManageChild(toolbar);
  antiright_create_button(toolbar, 
			  "New Directory",
			  antiright_mkdir_cb, 
			  "New Directory");
  antiright_create_button(toolbar, 
			  "Copy File",
			  antiright_copy_cb, 
			  "Copy File");
  antiright_create_button(toolbar, 
			  "Delete File",
			  antiright_delete_cb, 
			  "Delete File");
  XtAddCallback(antiright_filemanager_widget, 
		XmNokCallback, 
		antiright_filemanager_ok_cb, 
		"OK");
  
  XtAddCallback(antiright_filemanager_widget, 
		XmNcancelCallback, 
		cancel_cb, 
		"Close");
  XtAddCallback(antiright_filemanager_widget, 
		XmNhelpCallback, 
		antiright_help_cb, 
		"Select a file and then press an operation button.");
  file_list=
    XmFileSelectionBoxGetChild(antiright_filemanager_widget, 
			       XmDIALOG_LIST);
  XtAddCallback(file_list, XmNsingleSelectionCallback,
		antiright_filemanager_list_cb, NULL);
   
  XtManageChild(antiright_filemanager_widget);
  XmStringFree(apply_string);
  
  return(0);
}

void 
antiright_open_file()
{
  antiright_number_arguments=0;
  antiright_filemanager_widget=
    XmCreateFileSelectionDialog(antiright_parent_widget,
				"FileManager",
				antiright_arguments,
				antiright_number_arguments);
  XtAddCallback(antiright_filemanager_widget, 
		XmNokCallback, 
		antiright_file_open_ok_cb, 
		"OK");
  XtAddCallback(antiright_filemanager_widget, 
		XmNcancelCallback, 
		cancel_cb, 
		"Cancel");
  XtAddCallback(antiright_filemanager_widget, 
		XmNhelpCallback, 
		antiright_help_cb, 
		"Use this dialog to open a file in xmtextedit.");
  
  XtManageChild(antiright_filemanager_widget);
}
void
antiright_open_file_cb()
{
  antiright_open_file();
}
