/*************************************************************************
   AntiRight
   (c) 2003 Jeffrey Bedard
   jefbed@e-list.net
 
   This file is part of AntiRight.

    AntiRight is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    AntiRight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AntiRight; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "security.h"
#include "antiright.h"
#include "library.h"
#include "help.h"

int antiright_security_manager()
{
  Widget dialog;
  Widget child;
  Widget row[3];
  antiright_number_arguments = 0;
  dialog= 
    XmCreateMessageDialog(antiright_parent_widget, 
			  "Security", 
			  antiright_arguments, 
			  antiright_number_arguments);
  child=XmMessageBoxGetChild(dialog, 
			     XmDIALOG_OK_BUTTON);
  XtUnmanageChild(child);
  
  antiright_number_arguments = 0;
  XtSetArg(antiright_arguments[antiright_number_arguments],
	   XmNorientation,
	   XmHORIZONTAL);
  antiright_number_arguments++;
  row[0]=
    XmCreateRowColumn(dialog,
		      "row0",
		      antiright_arguments,
		      antiright_number_arguments);
  XtManageChild(row[0]);
  
  
  antiright_number_arguments = 0;
  XtSetArg(antiright_arguments[antiright_number_arguments],
	   XmNorientation,
	   XmVERTICAL);
  antiright_number_arguments++;
  row[1]=XmCreateRowColumn(row[0],
			   "row1",
			   antiright_arguments,
			   antiright_number_arguments);
  XtManageChild(row[1]);
  
  antiright_create_button(row[1],
			  "Fix User File Permissions",
			  antiright_system_cb,
			  "chmod -R og-rwx *");
  
  antiright_create_button(row[1],
			  "Fix Hidden File Permissions",
			  antiright_system_cb,
			  "chmod -R og-rwx .*");
  
  antiright_create_button(row[1],
			  "See User Processes...",
			  antiright_system_cb,
			  "xmmessage \"`ps xa`\" &");
  antiright_create_button(row[1],
			  "See Open Ports (requires nmap)...",
			  antiright_system_cb,
			  "xmmessage \"`nmap 127.0.0.1`\" &");
  XtAddCallback(dialog,
		XmNhelpCallback,
		antiright_help_cb,
		"This tool helps you monitor and strengthen your security.");
  XtAddCallback(dialog,
		XmNcancelCallback,
		cancel_cb,
		"Cancel");
  XtManageChild(dialog);
  
  return(0);
}
void antiright_security_cb()
{
  antiright_security_manager();    
}
