/*************************************************************************
   AntiRight
   (c) 2003 Jeffrey Bedard
   jefbed@e-list.net
 
   This file is part of AntiRight.

    AntiRight is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    AntiRight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AntiRight; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "antiright.h"

void antiright_xhost_ok_cb(Widget widget, 
			   XtPointer client_data, 
			   XtPointer call_data)
{
  XmSelectionBoxCallbackStruct* callback_struct_pointer;
  char *hostname;
  char *command;
  
  callback_struct_pointer=call_data;
  
  XmStringGetLtoR(callback_struct_pointer->value,
		  XmSTRING_DEFAULT_CHARSET,
		  &hostname);
  command=antiright_strcat("xhost  ", hostname);
  system(command);  
  free(command);
  XtUnmanageChild(widget);
  client_data=NULL;
}


void
antiright_xhost_cb(Widget widget, 
		   XtPointer client_data, 
		   XtPointer call_data)
{
    Widget dialog;
    XmString message;
    client_data=NULL;
    call_data=NULL;
    
    message=XmStringCreateLocalized("Host to allow:");
    antiright_number_arguments=0;
    XtSetArg(antiright_arguments[antiright_number_arguments],
	     XmNselectionLabelString,
	     message);
    antiright_number_arguments++;
    dialog=(Widget)XmCreatePromptDialog(widget, 
					"xhost", 
					antiright_arguments, 
					antiright_number_arguments);
    XmStringFree(message);
    XtAddCallback(dialog,
		  XmNokCallback,
		  antiright_xhost_ok_cb,
		  "OK");
    XtAddCallback(dialog,
		  XmNhelpCallback,
		  antiright_help_cb,
		  "The host entered will be allowed to use your display.");
    XtManageChild(dialog);
    
}
