/*************************************************************************
   AntiRight
   (c) 2003 Jeffrey Bedard
   jefbed@e-list.net
 
   This file is part of AntiRight.

    AntiRight is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    AntiRight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AntiRight; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/* This is AntiRight. AntiRight is a program that is meant to provide
   a lightweight control panel for the system.  AntiRight makes it
   easier to perform everyday system commands from the push of a
   button.  AntiRight was developed with Lesstif.
   
   This program is distributed under the terms of the GNU General
   Public Lecense.  To find out more, look at the file called COPYING
   in the project root directory.  */



/* This is the version control header.  */
/* 	$Id: xmmessage.c,v 1.5 2003/10/05 16:15:24 jefbed Exp $  */

#include <Xm/Xm.h>
#include <Xm/CascadeB.h>    
#include <Xm/Label.h>      
#include <Xm/MainW.h>       
#include <Xm/PushB.h>      
#include <Xm/RowColumn.h>   
#include <Xm/ScrollBar.h>
#include <Xm/Text.h>
#include <Xm/RowColumn.h>
#include <Xm/Frame.h>
#include <Xm/MessageB.h>
#include <Xm/ToggleB.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "../antiright-src/antiright.h"
#include "xmmessage.xbm"

/* FIXME: Comment these variables or make them local ! */
Arg arguments[20];
int number_arguments;
XtAppContext app_context;
Widget parent_widget;
Widget menubar_widget; 
Widget mainwindow_widget; 
Widget generic_widget;
Widget message_widget;
Widget text_widget;
Widget text1_widget; 
Widget row_widget;
Display *display;
void 
close_cb(){exit(0);}

/* This is the body of the application.  This sets up all of the main
   window's widgets, the menus, and the callbacks.  */
int
main(int argc, char* argv[])    
{
  Widget scrolled_text;
  Widget menu_widget;

  antiright_initialize_application(argc, argv);
  antiright_set_icon(antiright_parent_widget,
		     "Message",
		     xmmessage_bits,
		     xmmessage_width,
		     xmmessage_height);
  
  mainwindow_widget = XtVaCreateManagedWidget("Row", xmRowColumnWidgetClass, 
					      antiright_parent_widget, 
					      XmNorientation, XmVERTICAL, 
					      NULL);
  menubar_widget = XmCreateMenuBar(mainwindow_widget, 
				   "menubar", 
				   arguments, 
				   number_arguments);
  XtManageChild(menubar_widget);
  /* Begin File menu.  */
  menu_widget=antiright_create_pulldown_menu(menubar_widget, 
					     "File");
  antiright_create_button(menu_widget, 
			  "Close", 
			  close_cb, 
			  "Close");
  /* End File menu.  */
  /* Begin Help menu.  */
  menu_widget=antiright_create_help_menu(menubar_widget);
  /* End Help menu.  */
  
  number_arguments=0;
  XtSetArg( arguments[number_arguments], XmNeditable, False ); 
  number_arguments++;
  XtSetArg( arguments[number_arguments], XmNeditMode, XmMULTI_LINE_EDIT ); 
  number_arguments++;
  XtSetArg( arguments[number_arguments], XmNrows, 24 ); 
  number_arguments++;
  XtSetArg( arguments[number_arguments], XmNcolumns, 80 ); 
  number_arguments++;
  XtSetArg( arguments[number_arguments], XmNwordWrap, True ); 
  number_arguments++;
  XtSetArg( arguments[number_arguments], XmNscrollVertical, True ); 
  number_arguments++;
  XtSetArg( arguments[number_arguments], XmNscrollHorizontal, False ); 
  number_arguments++;
  scrolled_text = XmCreateScrolledText(mainwindow_widget, "scrolled_text", 
				       arguments, number_arguments);
  XtManageChild(scrolled_text);
  if(argc > 1)
    {
      XmTextInsert(scrolled_text, 
		   XmTextGetInsertionPosition(scrolled_text), 
		   argv[1]);
    }
  
  XtManageChild(menubar_widget);
  XtManageChild(mainwindow_widget);
  XtRealizeWidget(antiright_parent_widget);
  XtAppMainLoop(app_context);
  return(0);
}















