
/*************************************************************************
   AntiRight
   (c) 2003 Jeffrey Bedard
   jefbed@e-list.net
 
   This file is part of AntiRight.

    AntiRight is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    AntiRight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AntiRight; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include <Xm/Xm.h>
#include <Xm/CascadeB.h>        
#include <Xm/MainW.h>       
#include <Xm/PushB.h>      
#include <Xm/RowColumn.h>   
#include <Xm/ScrollBar.h>
#include <Xm/Text.h>
#include <Xm/MessageB.h>
#include <Xm/Label.h>
#include <Xm/SelectioB.h>
#include <Xm/RowColumn.h>
#include <Xm/FileSB.h>
#include <Xm/Form.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <sys/stat.h>
#include "xmsticky.xbm"
#include "../antiright-src/antiright.h"

Widget scrolled_text;

void 
close_cb()
{
  exit(0);
}
void new_cb()
{
  /* Some may question my constant use of system, but it reduces 
     complexity greatly, thus it is a great advantage.  */
  system("xmsticky &");
}

void cut_cb()
{
  XmTextCut(scrolled_text, XtLastTimestampProcessed(XtDisplay(scrolled_text)));
}
void copy_cb()
{
  XmTextCopy(scrolled_text, XtLastTimestampProcessed(XtDisplay(scrolled_text)));
}
void paste_cb()
{
  XmTextPaste(scrolled_text);
}


int
main(int argc, char* argv[])    
{
  Widget menu_widget, menubar_widget, mainwindow_widget;

  antiright_initialize_application(argc, argv);

  /*antiright_parent_widget= 
    XtVaOpenApplication(&app_context, 
			"XmTextEdit", 
			NULL, 
			0, 
			&argc, 
			argv, 
			NULL, 
			sessionShellWidgetClass,
			NULL, 
			NULL);*/
  antiright_set_icon(antiright_parent_widget,
		     "Note",
		     xmsticky_bits,
		     xmsticky_width,
		     xmsticky_height);

  mainwindow_widget = XtVaCreateManagedWidget("Row", 
					      xmFormWidgetClass, 
					      antiright_parent_widget, 
					      XmNorientation, XmVERTICAL, 
					      NULL);
  antiright_number_arguments=0;
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNleftAttachment, XmATTACH_FORM);
  antiright_number_arguments++;
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNrightAttachment, XmATTACH_FORM);
  antiright_number_arguments++;
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNtopAttachment, XmATTACH_FORM);
  antiright_number_arguments++;
  menubar_widget = XmCreateMenuBar(mainwindow_widget, 
				   "menubar", 
				   antiright_arguments, 
				   antiright_number_arguments);
  menu_widget = antiright_create_pulldown_menu(menubar_widget, "File");
  antiright_create_button(menu_widget,
			  "New",
			  new_cb,
			  "New");				
  antiright_create_button(menu_widget, 
			  "Close", 
			  close_cb, 
			  "Close");
  menu_widget=antiright_create_pulldown_menu(menubar_widget, "Edit");
	
  antiright_create_button(menu_widget,
			  "Cut",
			  cut_cb,
			  "Cut");
  antiright_create_button(menu_widget,
			  "Copy",
			  copy_cb,
			  "Copy");
  antiright_create_button(menu_widget,
			  "Paste",
			  paste_cb,
			  "Paste");
  menu_widget=antiright_create_help_menu(menubar_widget);

  antiright_number_arguments=0;
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNeditMode, XmMULTI_LINE_EDIT ); 
  antiright_number_arguments++;
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNrows, 8 ); 
  antiright_number_arguments++;
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNcolumns, 18 ); 
  antiright_number_arguments++;
  
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNscrollVertical, False ); 
  antiright_number_arguments++;
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNwordWrap, True);
  antiright_number_arguments++;
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNscrollHorizontal, False ); 
  antiright_number_arguments++;
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNbottomAttachment, XmATTACH_FORM);
  antiright_number_arguments++;
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNleftAttachment, XmATTACH_FORM);
  antiright_number_arguments++;
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNrightAttachment, XmATTACH_FORM);
  antiright_number_arguments++;
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNtopAttachment, XmATTACH_WIDGET);
  antiright_number_arguments++;
  XtSetArg(antiright_arguments[antiright_number_arguments], 
	   XmNtopWidget,  menubar_widget);
  antiright_number_arguments++;
  scrolled_text = 
    XmCreateScrolledText(mainwindow_widget, 
			 "sticky", 
			 antiright_arguments, antiright_number_arguments);

  XtManageChild(scrolled_text);
  XtManageChild(menubar_widget);
  XtManageChild(mainwindow_widget);
  XtRealizeWidget(antiright_parent_widget);
  XtAppMainLoop(app_context);
  return(0);
}

